local floor,random = math.floor,math.random
local sqrtwo = math.sqrt(2)
local magnetmax = 16

local debuggy=false
local ontick, tick = defines.events.on_tick
global.radii = global.radii or {}
local radii = global.radii

function dotick(event)
	if tick < 3 then tick = tick+1 return end
	tick=0
	
	local index, hand, surface
	for _,player in pairs(game.players) do
		index=player.position
		surface = player.surface
		if player.connected then
			hand = player.cursor_stack
			index = player.name
			
			if hand and hand.valid_for_read and hand.name=="magnet" then
				local posx,posy = player.position.x,player.position.y
				if radii[index] then
					radii[index] = radii[index] + .3
					if radii[index] > magnetmax then radii[index] = magnetmax end
				else
					radii[index] = 1
				end
				local magradius=radii[index]
				local mgsquare=magradius * magradius
				local mgroot= magradius / sqrtwo
				local dx,dy
				local itemlist = surface.find_entities_filtered{area={{x=posx-magradius,y=posy-magradius},{x=posx+magradius,y=posy+magradius}}, name="item-on-ground"}
				local thestack
				local badlist={}
				for k,v in pairs(itemlist) do
					thestack = v.stack
					if thestack then
						dx=v.position.x-posx
						if dx<0 then dx=-dx end
						dy=v.position.y-posy
						if dy<0 then dy=-dy end
						if (dx<mgroot and dy<mgroot) or (dx*dx+dy*dy < mgsquare) then
							if not badlist[thestack.name] and player.can_insert(thestack) then
								local r=player.get_item_count(thestack.name)
								player.insert(thestack)
								if player.get_item_count(thestack.name)~=r then
									itemlist[k].destroy()
								else
									badlist[thestack.name]=true
								end
							else
								--player.print("Cannot pick up "..thestack.name..".")
							end
						end
					end
				end
			else
				if radii[index] then radii[index]=nil end
			end
		end
	end
	if not next(radii) then script.on_event(ontick, nil) end
end

script.on_event(defines.events.on_player_cursor_stack_changed, function(e)
	local s = game.players[e.player_index].cursor_stack
	if s and s.valid_for_read and s.name=="magnet" then
		tick = e.tick%3
		script.on_event(ontick,dotick)
	end
end)

if debuggy then
script.on_event(defines.events.on_player_created, function(e)
	local p=game.players[e.player_index]
	p.insert("magnet")
	p.surface.spill_item_stack(p.position,{name="copper-cable",count=9999})
end)
end